﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;
using Example4Client.Example4ServiceReference;
using System.Diagnostics;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using System.ServiceModel.Discovery;

namespace Example4Client
{
    public partial class Form1 : Form
    {
        protected List<CMatrixClient> matrices;
        protected Dictionary<string,Stopwatch> timers;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            NetTcpBinding bind = new NetTcpBinding("NetTcpBinding_CMatrix");
            matrices = new List<CMatrixClient>();           
            bind.Security.Mode = SecurityMode.None;
            foreach (string url in serversListBox.CheckedItems)
            {
                CMatrixClient matrix = new CMatrixClient(bind, new EndpointAddress(url));
                matrix.Open();
                matrices.Add(matrix);
            }
            butConnect.Enabled = false;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            timeListBox.Items.Clear();
            timers = new Dictionary<string, Stopwatch>();
            int size = int.Parse(txtSize.Text);
            double dSize = 1.0 * size / matrices.Count;
            int min = int.Parse(txtMin.Text);
            int max = int.Parse(txtMax.Text);
            float [][]m1 = (float [][])Example4Lib.BinSerializer.Deserialize(matrices[0].Generate(size, min, max));
            float [][]m2 = (float[][])Example4Lib.BinSerializer.Deserialize(matrices[0].Generate(size, min, max));
            for (int k = 0; k < matrices.Count; k++)
            {
                Stopwatch timer = new Stopwatch();
                Example4Lib.CMatrixData data = new Example4Lib.CMatrixData();
                data.matrixOne = m1;
                data.matrixTwo = m2;
                data.beginInteration = (int)Math.Round(dSize * k);
                data.endIteration = (int)Math.Round(dSize * (k + 1));
                timer.Start();
                timers.Add(matrices[k].Endpoint.Address.ToString(), timer);
                //labResultTime.Visible = true;
                //labResultTime.Text = "идет решение...";
                matrices[k].BeginMultiple(Example4Lib.BinSerializer.Serialize(data), delegate(IAsyncResult ar)
                {
                    CMatrixClient curClient = (CMatrixClient)ar.AsyncState;
                    string url = curClient.Endpoint.Address.ToString();
                    Stream s = curClient.EndMultiple(ar);
                    timers[url].Stop();
                    if (timeListBox.InvokeRequired)
                    {
                        timeListBox.Invoke(new Action(delegate()
                        {
                            //labResultTime.Text = timer.Elapsed.ToString();
                            //labResultTime.Visible = true;
                            timeListBox.Items.Add(url + " - " + timers[url].Elapsed.ToString());
                        }));
                    }
                    else
                        timeListBox.Items.Add(url + " - " + timers[url].Elapsed.ToString());

                }, matrices[k]);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            UdpDiscoveryEndpoint end = new UdpDiscoveryEndpoint();
            DiscoveryClient client = new DiscoveryClient(end);
            FindCriteria crit = new FindCriteria(typeof(CMatrix));
            crit.Duration = new TimeSpan(0, 0, 3);
            FindResponse responce = client.Find(crit);
            serversListBox.Items.Clear();
            for (int i = 0; i < responce.Endpoints.Count; i++)
            {
                serversListBox.Items.Add(responce.Endpoints[i].Address.ToString(), true);
            }
        }
    }
}
