﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Discovery;
using Example4Lib;
using System.Net;

namespace Example4Server
{
    public partial class Form1 : Form
    {
        protected ServiceHost sh;
        public Form1()
        {
            InitializeComponent();
        }
        public void StartServer()
        {
            butStart.Enabled = false;
            butStop.Enabled = true;
            sh = new ServiceHost(typeof(CMatrix), 
                new Uri("net.tcp://" + ipComboBox.Text + ":9000/Mult"));
           
            NetTcpBinding bind = new NetTcpBinding("example4ServerBinding");
            bind.Security.Mode = SecurityMode.None;
            sh.AddServiceEndpoint(typeof(CMatrix), bind, "");
            
            ServiceMetadataBehavior sb = new ServiceMetadataBehavior();             
            sh.Description.Behaviors.Add(sb);
            sh.AddServiceEndpoint(typeof(IMetadataExchange), 
                 MetadataExchangeBindings.CreateMexTcpBinding(), 
                 "mex");

            sh.AddServiceEndpoint(new UdpDiscoveryEndpoint());
            ServiceDiscoveryBehavior sd = new ServiceDiscoveryBehavior();
            sh.Description.Behaviors.Add(sd);

            sh.Open();
        }

        public void StopServer()
        {
            butStart.Enabled = true;
            butStop.Enabled = false;
            sh.Close();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            labHostname.Text = Dns.GetHostName();
            IPAddress[] ips = Dns.GetHostAddresses(labHostname.Text);
            ipComboBox.Items.Clear();
            for (int i = 0; i < ips.Length; i++)
            {
                ipComboBox.Items.Add(ips[i].ToString());

            }
            ipComboBox.SelectedIndex = 0;
            butStop.Enabled = false;
            StartServer();
        }

        private void butStart_Click(object sender, EventArgs e)
        {
            StartServer();
        }

        private void butStop_Click(object sender, EventArgs e)
        {
            StopServer();
        }
    }
}
